package net.sergeych.bintools

/**
 * Create per-platform default named storage.
 *
 * - In the browser, it uses the `Window.localStorage` prefixing items
 *   by a string containing the [name]
 *
 * - In the JVM environment it uses folder-based storage on the file system. The name
 *   is considered to be a folder name (the whole path which will be automatically created)
 *   using the following rules:
 *    - when the name starts with slash (`/`) it is treated as an absolute path to a folder
 *    - when the name contains slash, it is considered to be a relative folder to the
 *      `User.home` directory, like "`~/`" on unix systems.
 *    - otherwise, the folder will be created in "`~/.local_storage`" parent directory
 *      (which also will be created if needed).
 *
 *  - For the native platorms it is not yet implemented (but will be soon).
 *
 *  See [DataKVStorage] and [DataProvider] to implement a KVStorage on filesystems and like,
 *  and `FileDataProvider` class on JVM target.
 */
actual fun defaultNamedStorage(name: String): KVStorage {
    TODO("Not yet implemented")
}